/*=============================================================================
    Copyright (c) 2007-2008 Dan Marsden

    Distributed under the Boost Software License, Version 1.0. (See accompanying 
    file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
==============================================================================*/

#if !defined(BOOST_TRAVERSAL_MATCH_20080406_1514)
#define BOOST_TRAVERSAL_MATCH_20080406_1514

#include <boost/utility/enable_if.hpp>

#include <boost/mpl/apply.hpp>

namespace boost { namespace traversal {

    namespace detail
    {
        template<typename MetaFuncClass, typename Func>
        struct match
        {
            explicit match(Func f)
                : f_(f)
            {}

            Func f_;

            template<typename T>
            typename boost::enable_if<typename mpl::apply<MetaFuncClass, T>::type, bool>::type
            operator()(T& t) const
            {
                return f_(t);
            }

            template<typename T>
            typename boost::disable_if<typename mpl::apply<MetaFuncClass, T>::type, bool>::type
            operator()(T&) const
            {
                return false;
            }
        };
    }

    template<typename MetaFuncClass, typename Func>
    detail::match<MetaFuncClass, Func>
    match(Func func)
    {
        return detail::match<MetaFuncClass, Func>(func);
    }
}}

#endif
