/*=============================================================================
    Copyright (c) 2007-2008 Dan Marsden

    Distributed under the Boost Software License, Version 1.0. (See accompanying 
    file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
==============================================================================*/
#if !defined(BOOST_TRAVERSE_PASS_THROUGH_20070924_1646)
#define BOOST_TRAVERSE_PASS_THROUGH_20070924_1646

#include <boost/traversal/functional/detail/constant.hpp>

namespace boost { namespace traversal {
    namespace detail
    {
        struct pass_through
        {
            template<typename Sig>
            struct result;

            template<typename State, typename Arg>
            struct result<pass_through(State, Arg)>
            {
                typedef State type;
            };

            template<typename State, typename Arg>
            State operator()(State state, Arg) const
            {
                return state;
            }

            template<typename State, typename Arg0, typename Arg1>
            State operator()(State state, Arg0&, Arg1&) const
            {
                return state;
            }
        };
    }

    detail::pass_through const pass_through = {};
}}

#endif
