/*=============================================================================
    Copyright (c) 2007-2008 Dan Marsden

    Distributed under the Boost Software License, Version 1.0. (See accompanying 
    file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
==============================================================================*/
#if !defined(BOOST_TRAVERSAL_TU_RESTRICT_20080315_1229)
#define BOOST_TRAVERSAL_TU_RESTRICT_20080315_1229

namespace boost { namespace traversal {
    namespace detail
    {
        template<typename Sig, typename Func>
        struct tu_restrict;

        template<typename Ret, typename Arg0, typename Arg1, typename Func>
        struct tu_restrict<Ret(Arg0,Arg1), Func>
        {
            typedef Ret result_type;

            explicit tu_restrict(Func f)
                : f_(f)
                {}

            Ret operator()(Arg0 state, Arg1 a1) const
                {
                    return f_(state, a1);
                }

            template<typename U0>
            Ret operator()(Arg0 state, U0& a1) const
                {
                    return state;
                }

            Func f_;
        };

        template<typename Ret, typename Arg0, typename Arg1, typename Arg2, typename Func>
        struct tu_restrict<Ret(Arg0,Arg1,Arg2), Func>
        {
            typedef Ret result_type;

            explicit tu_restrict(Func f)
                : f_(f)
                {}

            Ret operator()(Arg0 state, Arg1 a1, Arg2 a2) const
                {
                    return f_(state, a1, a2);
                }

            template<typename U0, typename U1>
            Ret operator()(Arg0 state, U0& a1, U1& a2) const
                {
                    return state;
                }

            Func f_;
        };
    }

    template<typename Sig, typename F>
    detail::tu_restrict<Sig, F>
    tu_restrict(F f)
    {
        return detail::tu_restrict<Sig, F>(f);
    }
}}

#endif
