/*=============================================================================
    Copyright (c) 2007-2008 Dan Marsden

    Distributed under the Boost Software License, Version 1.0. (See accompanying 
    file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
==============================================================================*/
#if !defined(BOOST_TRAVERSAL_UNSTRUCTURED_20070926_0745)
#define BOOST_TRAVERSAL_UNSTRUCTURED_20070926_0745

#include <boost/traversal/support/tag_of.hpp>

namespace boost { namespace traversal {
    namespace detail
    {
        template<typename Horiz, typename Unstructured>
        struct unstructured_impl
            : Horiz
        {
            typedef bool result_type;

            explicit unstructured_impl(Horiz const& horiz)
                : Horiz(horiz)
            {}

            using Horiz::operator();

            template<typename UnaryFunc>
            bool operator()(Unstructured& t, UnaryFunc f) const
            {
                return (*this)(t, f, traits::unstructured_tag());
            }
        };

        template<typename TuHoriz, typename Unstructured>
        struct tu_unstructured_impl
            : TuHoriz
        {
            template<typename Sig>
            struct result
                : TuHoriz::template result<Sig>
            {};

            explicit tu_unstructured_impl(TuHoriz const& horiz)
                : TuHoriz(horiz)
            {}

            using TuHoriz::operator();

            template<typename UnaryFunc, typename State>
            std::pair<State, bool>
            operator()(Unstructured& t, UnaryFunc f, State state) const
            {
                return (*this)(t, f, state, traits::unstructured_tag());
            }
        };
    }

    template<typename Unstructured, typename Horiz>
    detail::unstructured_impl<Horiz, Unstructured>
    unstructured(Horiz const& horiz)
    {
        return detail::unstructured_impl<Horiz, Unstructured>(horiz);
    }

    template<typename Unstructured, typename Horiz>
    detail::tu_unstructured_impl<Horiz, Unstructured>
    tu_unstructured(Horiz const& horiz)
    {
        return detail::tu_unstructured_impl<Horiz, Unstructured>(horiz);
    }
}}

#endif
