/*=============================================================================
    Copyright (c) 2007-2008 Dan Marsden

    Distributed under the Boost Software License, Version 1.0. (See accompanying 
    file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
==============================================================================*/
#if !defined(BOOST_TRAVERSAL_FUSION_ONE_20070922_1711)
#define BOOST_TRAVERSAL_FUSION_ONE_20070922_1711

#include <boost/fusion/iterator/equal_to.hpp>
#include <boost/fusion/iterator/next.hpp>
#include <boost/fusion/iterator/deref.hpp>
#include <boost/fusion/sequence/intrinsic/begin.hpp>
#include <boost/fusion/sequence/intrinsic/end.hpp>
#include <boost/mpl/bool.hpp>

namespace boost { namespace traversal { namespace detail {
    template<typename First, typename Last, typename UnaryFunc>
    bool
    fusion_one_impl(First const& first, Last const& last, UnaryFunc f, mpl::true_)
    {
        return false;
    }

    template<typename First, typename Last, typename UnaryFunc>
    bool
    fusion_one_impl(First const& first, Last const& last, UnaryFunc f, mpl::false_)
    {
        namespace fusion = boost::fusion;
        return f(*first) ||
            fusion_one_impl(fusion::next(first), last, f,
                fusion::result_of::equal_to<typename fusion::result_of::next<First>::type, Last>());
    }

    template<typename Seq, typename UnaryFunc>
    bool fusion_one(Seq& seq, UnaryFunc f)
    {
        namespace fusion = boost::fusion;
        typedef typename fusion::result_of::begin<Seq>::type First;
        typedef typename fusion::result_of::end<Seq>::type Last;

        return fusion_one_impl(fusion::begin(seq), fusion::end(seq), f, 
                  fusion::result_of::equal_to<First, Last>());
    }
}}}

#endif
