/*=============================================================================
    Copyright (c) 2007-2008 Dan Marsden

    Distributed under the Boost Software License, Version 1.0. (See accompanying 
    file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
==============================================================================*/
#if !defined(BOOST_TRAVERSAL_ONE_20070922_1705)
#define BOOST_TRAVERSAL_ONE_20070922_1705

#include <boost/traversal/support/tag_of.hpp>
#include <boost/traversal/horizontal/detail/fusion_one.hpp>
#include <boost/traversal/horizontal/detail/iter_one.hpp>
#include <boost/traversal/horizontal/detail/variant_one.hpp>
#include <boost/traversal/horizontal/detail/grab_ptr.hpp>

namespace boost { namespace traversal { namespace extension {
    template<typename T, typename UnaryFunc>
    bool one(T& t, UnaryFunc f, traits::unstructured_tag)
    {
        return false;
    }

    template<typename T, typename UnaryFunc>
    bool one(T& t, UnaryFunc f, traits::container_tag)
    {
        return detail::iter_one(t.begin(), t.end(), f);
    }

    template<typename T, typename UnaryFunc>
    bool one(T& t, UnaryFunc f, traits::fusion_sequence_tag)
    {
        return detail::fusion_one(t, f);
    }

    template<typename T, typename UnaryFunc>
    bool one(T& o, UnaryFunc f, traits::optional_tag)
    {
        return o ? f(o.get()) : false;
    }

    template<typename T, typename UnaryFunc>
    bool one(T& ptr, UnaryFunc f, traits::pointer_tag)
    {
        detail::grab_ptr<T> grabbed(ptr);
        return grabbed.ptr ? f(*grabbed.ptr) : false;
    }

    template<typename T, typename UnaryFunc>
    bool one(T& t, UnaryFunc f,
             traits::variant_tag)
    {
        return detail::variant_one(t, f);
    }
}}}

#endif
