/*=============================================================================
    Copyright (c) 2007-2008 Dan Marsden

    Distributed under the Boost Software License, Version 1.0. (See accompanying 
    file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
==============================================================================*/
#if !defined(BOOST_TRAVERSAL_TU_ALWAYS_20070922_1800)
#define BOOST_TRAVERSAL_TU_ALWAYS_20070922_1800

#include <utility>

namespace boost { namespace traversal { namespace detail {
    template<typename UnaryFunc>
    struct tu_always
    {
        explicit tu_always(UnaryFunc f)
            : f(f)
        {}

        template<typename State, typename U>
        State operator()(State state, U& u) const
        {
            return std::make_pair(f(state, u).first, false);
        }

        UnaryFunc f;
    };

    template<typename UnaryFunc>
    tu_always<UnaryFunc> make_tu_always(UnaryFunc f)
    {
        return tu_always<UnaryFunc>(f);
    }
}}}

#endif
