/*=============================================================================
    Copyright (c) 2007-2008 Dan Marsden

    Distributed under the Boost Software License, Version 1.0. (See accompanying 
    file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
==============================================================================*/
#if !defined(BOOST_TRAVERSAL_TU_ONE_20070922_1705)
#define BOOST_TRAVERSAL_TU_ONE_20070922_1705

#include <boost/traversal/support/tag_of.hpp>
#include <boost/traversal/horizontal/detail/fusion_tu_one.hpp>
#include <boost/traversal/horizontal/detail/iter_tu_one.hpp>
#include <boost/traversal/horizontal/detail/variant_tu_one.hpp>
#include <boost/traversal/horizontal/detail/grab_ptr.hpp>
#include <utility>

namespace boost { namespace traversal { namespace extension {
    template<typename T, typename UnaryFunc, typename State>
    State tu_one(T& t, UnaryFunc f, State state, traits::unstructured_tag)
    {
        return state;
    }

    template<typename T, typename UnaryFunc, typename State>
    State tu_one(T& t, UnaryFunc f, State state, traits::container_tag)
    {
        return boost::traversal::detail::iter_tu_one(t.begin(), t.end(), f, state);
    }

    template<typename T, typename UnaryFunc, typename State>
    State tu_one(T& t, UnaryFunc f, State state, traits::fusion_sequence_tag)
    {
        return detail::fusion_tu_one(t, f, state);
    }

    template<typename T, typename UnaryFunc, typename State>
    State tu_one(T& o, UnaryFunc f, State state, traits::optional_tag)
    {
        return o ? f(state, o.get()) : state;
    }

    template<typename T, typename UnaryFunc, typename State>
    State tu_one(T& ptr, UnaryFunc f, State state, traits::pointer_tag)
    {
        detail::grab_ptr<T> grabbed(ptr);
        return grabbed.ptr ? f(state, *grabbed.ptr) : state;
    }

    template<typename T, typename UnaryFunc, typename State>
    State tu_one(T& t, UnaryFunc f, State state,
                 traits::variant_tag)
    {
        return detail::variant_tu_one(t, f, state);
    }
}}}

#endif
