/*=============================================================================
    Copyright (c) 2007-2008 Dan Marsden

    Distributed under the Boost Software License, Version 1.0. (See accompanying 
    file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
==============================================================================*/
#if !defined(BOOST_TRAVERSAL_VARIANT_ONE_20070924_1751)
#define BOOST_TRAVERSAL_VARIANT_ONE_20070924_1751

#include <boost/variant.hpp>

namespace boost { namespace traversal { namespace detail {
    template<typename UnaryFunc>
    struct visitor_wrapper
        : boost::static_visitor<bool>
    {
        explicit visitor_wrapper(UnaryFunc func)
            : func(func)
        {}

        template<typename U>
        bool operator()(U& u) const
        {
            return func(u);
        }

        UnaryFunc func;
    };

    template<typename UnaryFunc>
    visitor_wrapper<UnaryFunc>
    make_visitor(UnaryFunc func)
    {
        return visitor_wrapper<UnaryFunc>(func);
    }

    template<typename T, typename UnaryFunc>
    bool variant_one(T& t, UnaryFunc f)
    {
        return boost::apply_visitor(detail::make_visitor(f), t);
    }
}}}

#endif
