/*=============================================================================
    Copyright (c) 2007-2008 Dan Marsden

    Distributed under the Boost Software License, Version 1.0. (See accompanying 
    file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
==============================================================================*/
#if !defined(BOOST_TRAVERSAL_REVERSE_ONE_20070922_1747)
#define BOOST_TRAVERSAL_REVERSE_ONE_20070922_1747

#include <boost/traversal/support/tag_of.hpp>
#include <boost/traversal/horizontal/detail/reverse_one.hpp>

namespace boost { namespace traversal {
    struct reverse_one_traversal
    {
        typedef bool result_type;

        template<typename T, typename UnaryFunc, typename Tag>
        bool operator()(T& t, UnaryFunc f, Tag tag) const
        {
            return extension::reverse_one(t, f, tag);
        }

        template<typename T, typename UnaryFunc>
        bool operator()(T& t, UnaryFunc f) const
        {
            return (*this)(t, f, typename traits::tag_of<T>::type());
        }
    };

    reverse_one_traversal const reverse_one = {};
}}

#endif
