/*=============================================================================
    Copyright (c) 2007-2008 Dan Marsden

    Distributed under the Boost Software License, Version 1.0. (See accompanying 
    file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
==============================================================================*/
#if !defined(BOOST_TRAVERSAL_TU_REVERSE_ALL_20070922_1758)
#define BOOST_TRAVERSAL_TU_REVERSE_ALL_20070922_1758

#include <boost/traversal/horizontal/tu_reverse_one.hpp>
#include <boost/traversal/horizontal/detail/tu_always.hpp>

namespace boost { namespace traversal {
    struct tu_reverse_all_traversal
    {
        template<typename Sig>
        struct result;

        template<typename T, typename UnaryFunc, typename State, typename Tag>
        struct result<tu_reverse_all_traversal(T&, UnaryFunc, State, Tag)>
        {
            typedef std::pair<State, bool> type;
        };

        template<typename T, typename UnaryFunc, typename State>
        struct result<tu_reverse_all_traversal(T&, UnaryFunc, State)>
        {
            typedef std::pair<State, bool> type;
        };

        template<typename T, typename UnaryFunc, typename State, typename Tag>
        std::pair<State, bool>
        operator()(T& t, UnaryFunc f, State state, Tag tag) const
        {
            return tu_reverse_one(t, detail::make_tu_always(f), state, tag);
        }

        template<typename T, typename UnaryFunc, typename State>
        std::pair<State, bool>
        operator()(T& t, UnaryFunc f, State state) const
        {
            return tu_reverse_one(t, detail::make_tu_always(f), state);
        }
    };

    tu_reverse_all_traversal const tu_reverse_all = {};
}}

#endif
