/*=============================================================================
    Copyright (c) 2007-2008 Dan Marsden

    Distributed under the Boost Software License, Version 1.0. (See accompanying 
    file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
==============================================================================*/

#if !defined(BOOST_TRAVERSAL_BOOST_POINTER_20080406_1500)
#define BOOST_TRAVERSAL_BOOST_POINTER_20080406_1500

#include <boost/mpl/bool.hpp>
#include <boost/mpl/apply.hpp>

#include <boost/shared_ptr.hpp>
#include <boost/scoped_ptr.hpp>
#include <boost/shared_array.hpp>
#include <boost/scoped_array.hpp>
#include <boost/weak_ptr.hpp>
#include <boost/intrusive_ptr.hpp>

namespace boost { namespace traversal { namespace pattern {

#define BOOST_TRAVERSAL_POINTER_PATTERN(POINTER)    \
    template<typename Member>                       \
    struct POINTER                                  \
    {                                               \
        template<typename T>                        \
        struct apply                                \
            : mpl::false_                           \
        {};                                         \
                                                    \
        template<typename T>                        \
        struct apply<boost::POINTER<T> >            \
            : mpl::apply<Member, T>                 \
        {};                                         \
    }

    BOOST_TRAVERSAL_POINTER_PATTERN(shared_ptr);
    BOOST_TRAVERSAL_POINTER_PATTERN(scoped_ptr);
    BOOST_TRAVERSAL_POINTER_PATTERN(scoped_array);
    BOOST_TRAVERSAL_POINTER_PATTERN(shared_array);
    BOOST_TRAVERSAL_POINTER_PATTERN(weak_ptr);
    BOOST_TRAVERSAL_POINTER_PATTERN(intrusive_ptr);

#undef BOOST_TRAVERSAL_POINTER_PATTERN
}}}

#endif
