/*=============================================================================
    Copyright (c) 2007-2008 Dan Marsden

    Distributed under the Boost Software License, Version 1.0. (See accompanying 
    file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
==============================================================================*/

#if !defined(BOOST_TRAVERSAL_CONTAINER_20080406_0950)
#define BOOST_TRAVERSAL_CONTAINER_20080406_0950

#include <vector>
#include <list>
#include <deque>

#include <boost/mpl/bool.hpp>
#include <boost/mpl/and.hpp>
#include <boost/mpl/apply.hpp>

namespace boost { namespace traversal { namespace pattern {

#define BOOST_TRAVERSAL_STD_CONTAINER_PATTERN(CONT) \
    template<typename Member>                       \
    struct CONT                                     \
    {                                               \
        template<typename T>                        \
        struct apply                                \
            : mpl::false_                           \
        {};                                         \
                                                    \
        template<typename T>                        \
        struct apply<std::CONT<T> >                 \
            : mpl::apply<Member, T>                 \
        {};                                         \
    }

    BOOST_TRAVERSAL_STD_CONTAINER_PATTERN(vector);
    BOOST_TRAVERSAL_STD_CONTAINER_PATTERN(list);
    BOOST_TRAVERSAL_STD_CONTAINER_PATTERN(deque);

#undef BOOST_TRAVERSAL_STD_CONTAINER_PATTERN
}}}

#endif
