/*=============================================================================
    Copyright (c) 2007-2008 Dan Marsden

    Distributed under the Boost Software License, Version 1.0. (See accompanying 
    file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
==============================================================================*/

#if !defined(BOOST_TRAVERSAL_DETAIL_ALL_PREDICATES_20080406_1654)
#define BOOST_TRAVERSAL_DETAIL_ALL_PREDICATES_20080406_1654

#include <boost/mpl/begin_end.hpp>
#include <boost/mpl/zip_view.hpp>
#include <boost/mpl/vector/vector10.hpp>
#include <boost/mpl/apply.hpp>
#include <boost/mpl/at.hpp>
#include <boost/mpl/equal_to.hpp>
#include <boost/mpl/lambda.hpp>
#include <boost/mpl/find_if.hpp>
#include <boost/mpl/not.hpp>

#include <boost/type_traits/is_same.hpp>

namespace boost { namespace traversal { namespace detail {

    template<typename Seq>
    struct apply_pred_to_arg
        : mpl::not_<mpl::apply<
        typename mpl::at_c<Seq, 0>::type,
        typename mpl::at_c<Seq, 1>::type > >
    {};

    template<
        typename UnaryPredicates,
        typename Arguments>
    struct all_predicates
    {
        typedef mpl::zip_view<
            mpl::vector2<UnaryPredicates, Arguments> > zipped;

        typedef typename mpl::find_if<
            zipped, apply_pred_to_arg<mpl::_> >::type found;

        typedef is_same<
            found, typename mpl::end<zipped>::type> type;
    };
}}}

#endif
