/*=============================================================================
    Copyright (c) 2007-2008 Dan Marsden

    Distributed under the Boost Software License, Version 1.0. (See accompanying 
    file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
==============================================================================*/

#if !defined(BOOST_TRAVERSAL_PAIR_20080406_1025)
#define BOOST_TRAVERSAL_PAIR_20080406_1025

#include <boost/mpl/bool.hpp>
#include <boost/mpl/and.hpp>
#include <boost/mpl/apply.hpp>

#include <utility>

namespace boost { namespace traversal { namespace pattern {
    template<typename Lhs, typename Rhs>
    struct pair
    {
        template<typename T>
        struct apply
            : mpl::false_
        {};

        template<typename L, typename R>
        struct apply<std::pair<L, R> >
            : mpl::and_<
            mpl::apply<Lhs, L>,
            mpl::apply<Rhs, R> >
        {};
    };
}}}

#endif
