/*=============================================================================
    Copyright (c) 2007-2008 Dan Marsden

    Distributed under the Boost Software License, Version 1.0. (See accompanying 
    file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
==============================================================================*/
#if !defined(BOOST_TRAVERSAL_BU_ONCE_PARENT_20070922_1906)
#define BOOST_TRAVERSAL_BU_ONCE_PARENT_20070922_1906

#include <boost/traversal/horizontal/one.hpp>
#include <boost/traversal/recursive/traverse_parent.hpp>
#include <boost/traversal/recursive/detail/choose_parent.hpp>
#include <boost/traversal/functional/false.hpp>

namespace boost { namespace traversal {
    struct bu_once_parent_traversal
    {
        typedef bool result_type;

        template<typename T, typename UnaryFunc>
        bool operator()(T& t, UnaryFunc f) const
        {
            return traverse_parent(t, false_, f, one, detail::choose_parent);
        }

        template<typename T, typename UnaryFunc, typename One>
        bool operator()(T& t, UnaryFunc f, One const& one) const
        {
            return traverse_parent(t, false_, f, one, detail::choose_parent);
        }
    };

    bu_once_parent_traversal const bu_once_parent = {};
}}

#endif
