/*=============================================================================
    Copyright (c) 2007-2008 Dan Marsden

    Distributed under the Boost Software License, Version 1.0. (See accompanying 
    file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
==============================================================================*/
#if !defined(BOOST_TRAVERSAL_BU_TU_FULL_20070922_1825)
#define BOOST_TRAVERSAL_BU_TU_FULL_20070922_1825

#include <boost/traversal/horizontal/tu_all.hpp>
#include <boost/traversal/recursive/tu_traverse.hpp>
#include <boost/traversal/recursive/detail/tu_sequence.hpp>
#include <boost/traversal/functional/pass_through.hpp>

namespace boost { namespace traversal {
    struct bu_tu_full_traversal
    {
        template<typename Sig>
        struct result;

        template<typename T, typename UnaryFunc, typename State>
        struct result<bu_tu_full_traversal(T&, UnaryFunc, State)>
        {
            typedef State type;
        };

        template<typename T, typename UnaryFunc, typename State, typename TuAll>
        struct result<bu_tu_full_traversal(T&, UnaryFunc, State, TuAll)>
        {
            typedef State type;
        };

        template<typename T, typename State, typename UnaryFunc>
        std::pair<State, bool>
        operator()(T& t, State state, UnaryFunc f) const
        {
            return tu_traverse(t, state, pass_through, 
                               f, tu_all, detail::tu_sequence);
        }

        template<typename T, typename State, typename UnaryFunc, typename TuAll>
        std::pair<State, bool>
        operator()(T& t, State state, UnaryFunc f, TuAll const& tu_all) const
        {
            return tu_traverse(t, state, pass_through, 
                               f, tu_all, detail::tu_sequence);
        }
    };

    bu_tu_full_traversal const bu_tu_full = {};
}}

#endif
