/*=============================================================================
    Copyright (c) 2007-2008 Dan Marsden

    Distributed under the Boost Software License, Version 1.0. (See accompanying 
    file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
==============================================================================*/
#if !defined(BOOST_TRAVERSAL_BU_TU_REVERSE_SPINE_PARENT_20070922_1825)
#define BOOST_TRAVERSAL_BU_TU_REVERSE_SPINE_PARENT_20070922_1825

#include <boost/traversal/horizontal/tu_reverse_one.hpp>
#include <boost/traversal/recursive/tu_traverse_parent.hpp>
#include <boost/traversal/recursive/detail/tu_choose_parent.hpp>
#include <boost/traversal/functional/pass_through.hpp>

namespace boost { namespace traversal {
    struct bu_tu_reverse_spine_parent_traversal
    {
        template<typename Sig>
        struct result;

        template<typename T, typename UnaryFunc, typename State>
        struct result<bu_tu_reverse_spine_parent_traversal(T&, UnaryFunc, State)>
        {
            typedef State type;
        };

        template<typename T, typename UnaryFunc, typename State, typename TuReverse_One>
        struct result<bu_tu_reverse_spine_parent_traversal(T&, UnaryFunc, State, TuReverse_One)>
        {
            typedef State type;
        };

        template<typename T, typename State, typename UnaryFunc>
        std::pair<State, bool>
        operator()(T& t, State state, UnaryFunc f) const
        {
            return tu_traverse_parent(t, state, pass_through, 
                                      f, tu_reverse_one, detail::tu_choose_parent);
        }

        template<typename T, typename State, typename UnaryFunc, typename TuReverse_One>
        std::pair<State, bool>
        operator()(T& t, State state, UnaryFunc f, TuReverse_One const& tu_reverse_one) const
        {
            return tu_traverse_parent(t, state, pass_through, 
                                      f, tu_reverse_one, detail::tu_choose_parent);
        }
    };

    bu_tu_reverse_spine_parent_traversal const bu_tu_reverse_spine_parent = {};
}}

#endif
