/*=============================================================================
    Copyright (c) 2007-2008 Dan Marsden

    Distributed under the Boost Software License, Version 1.0. (See accompanying 
    file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
==============================================================================*/
#if !defined(BOOST_TRAVERSAL_TU_CHOOSE_20070924_1639)
#define BOOST_TRAVERSAL_TU_CHOOSE_20070924_1639

namespace boost { namespace traversal { namespace detail {
    struct tu_choose_impl
    {
        template<
            typename T,
            typename State,
            typename InUnaryFunc, 
            typename OutUnaryFunc, 
            typename OneImplementation, 
            typename RecursiveUnaryFunc>
        State operator()(T& t, State state, InUnaryFunc in, OutUnaryFunc out, 
                        OneImplementation one, RecursiveUnaryFunc rec) const
        {
            state = in(state, t);
            if(state.second)
                return state;

            state = one(t, rec, state.first);
            if(state.second)
                return state;

            return out(state, t);
        }
    };

    tu_choose_impl const tu_choose = {};
}}}

#endif
