/*=============================================================================
    Copyright (c) 2007-2008 Dan Marsden

    Distributed under the Boost Software License, Version 1.0. (See accompanying 
    file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
==============================================================================*/
#if !defined(BOOST_TRAVERSAL_FULL_PARENT_20070930_1415)
#define BOOST_TRAVERSAL_FULL_PARENT_20070930_1415

#include <boost/traversal/horizontal/all.hpp>
#include <boost/traversal/recursive/traverse_parent.hpp>
#include <boost/traversal/recursive/detail/sequence_parent.hpp>
#include <boost/traversal/functional/false.hpp>

namespace boost { namespace traversal {
    struct full_parent_traversal
    {
        typedef bool result_type;

        template<typename T, typename UnaryFunc>
        bool operator()(T& t, UnaryFunc f) const
        {
            return traverse_parent(t, f, false_, all, detail::sequence_parent);
        }

        template<typename T, typename UnaryFunc, typename All>
        bool operator()(T& t, UnaryFunc f, All const& all) const
        {
            return traverse_parent(t, f, false_, all, detail::sequence_parent);
        }
    };

    full_parent_traversal const full_parent = {};
}}

#endif
