/*=============================================================================
    Copyright (c) 2007-2008 Dan Marsden

    Distributed under the Boost Software License, Version 1.0. (See accompanying 
    file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
==============================================================================*/
#if !defined(BOOST_TRAVERSAL_STOP_20070924_1708)
#define BOOST_TRAVERSAL_STOP_20070924_1708

#include <boost/traversal/horizontal/all.hpp>
#include <boost/traversal/recursive/traverse.hpp>
#include <boost/traversal/recursive/detail/choose.hpp>
#include <boost/traversal/functional/false.hpp>

namespace boost { namespace traversal {
    struct stop_traversal
    {
        typedef bool result_type;

        template<typename T, typename UnaryFunc>
        bool operator()(T& t, UnaryFunc f) const
        {
            return traverse(t, f, false_, all, detail::choose);
        }

        template<typename T, typename UnaryFunc, typename All>
        bool operator()(T& t, UnaryFunc f, All const& all) const
        {
            return traverse(t, f, false_, all, detail::choose);
        }
    };

    stop_traversal const stop = {};
}}

#endif
