/*=============================================================================
    Copyright (c) 2007-2008 Dan Marsden

    Distributed under the Boost Software License, Version 1.0. (See accompanying 
    file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
==============================================================================*/
#if !defined(BOOST_TRAVERSAL_IS_FUSION_SEQUENCE_20070830)
#define BOOST_TRAVERSAL_IS_FUSION_SEQUENCE_20070830

#include <boost/mpl/and.hpp>
#include <boost/mpl/not.hpp>

#include <boost/traversal/support/is_variant.hpp>
#include <boost/fusion/support/is_sequence.hpp>

namespace boost { namespace traversal {
    namespace traits
    {
        template<typename T>
        struct is_fusion_sequence
            : mpl::and_<
            fusion::traits::is_sequence<T>,
            mpl::not_<is_variant<T> > >
        {};
    }
}}

#endif
