/*=============================================================================
    Copyright (c) 2007-2008 Dan Marsden

    Distributed under the Boost Software License, Version 1.0. (See accompanying 
    file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
==============================================================================*/
#if !defined(BOOST_TRAVERSAL_TAG_OF_20070921_1336)
#define BOOST_TRAVERSAL_TAG_OF_20070921_1336

#include <boost/traversal/support/is_pointer.hpp>
#include <boost/traversal/support/is_container.hpp>
#include <boost/traversal/support/is_variant.hpp>
#include <boost/traversal/support/is_optional.hpp>
#include <boost/traversal/support/is_fusion_sequence.hpp>

#include <boost/utility/enable_if.hpp>

namespace boost { namespace traversal { namespace traits {

    struct unstructured_tag {};
    struct container_tag {};
    struct fusion_sequence_tag {};
    struct optional_tag {};
    struct variant_tag {};
    struct pointer_tag {};

    template<typename T, typename Enabler = void>
    struct tag_of
    {
        typedef unstructured_tag type;
    };

    template<typename T>
    struct tag_of<T, typename boost::enable_if<is_container<T> >::type>
    {
        typedef container_tag type;
    };

    template<typename T>
    struct tag_of<T, typename boost::enable_if<is_fusion_sequence<T> >::type>
    {
        typedef fusion_sequence_tag type;
    };

    template<typename T>
    struct tag_of<T, typename boost::enable_if<is_variant<T> >::type>
    {
        typedef variant_tag type;
    };

    template<typename T>
    struct tag_of<T, typename boost::enable_if<is_optional<T> >::type>
    {
        typedef optional_tag type;
    };

    template<typename T>
    struct tag_of<T, typename boost::enable_if<is_pointer<T> >::type>
    {
        typedef pointer_tag type;
    };
}}}

#endif
