/*=============================================================================
    Copyright (c) 2007-2008 Dan Marsden

    Distributed under the Boost Software License, Version 1.0. (See accompanying 
    file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
==============================================================================*/
#include <boost/detail/lightweight_test.hpp>
#include <boost/traversal/functional/match.hpp>

#include <boost/mpl/bool.hpp>
#include <boost/mpl/lambda.hpp>

#include <boost/type_traits/is_same.hpp>

namespace traversal = boost::traversal;
namespace mpl = boost::mpl;

namespace
{
    struct increment
    {
        bool operator()(int& i) const
        {
            ++i;
            return false;
        }
    };

    struct integer
    {
        template<typename T>
        struct apply
            : boost::is_same<int, T>
        {};
    };
}

int main()
{
    int i = 0;
    double d = 0.0;
    
    traversal::match<boost::is_same<int, mpl::_> >(increment())(i);
    traversal::match<boost::is_same<int, mpl::_> >(increment())(d);

    BOOST_TEST(i == 1);
    BOOST_TEST(d == 0.0);
    return boost::report_errors();
}
