/*=============================================================================
    Copyright (c) 2007-2008 Dan Marsden

    Distributed under the Boost Software License, Version 1.0. (See accompanying 
    file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
==============================================================================*/
#include <boost/detail/lightweight_test.hpp>
#include <boost/traversal/functional/tu_extend.hpp>

#include <utility>

namespace
{
    std::pair<int, bool>
    add1(std::pair<int, bool> pr, int value)
    {
        pr.first += value;
        return pr;
    }

    std::pair<int, bool>
    add2(std::pair<int, bool> pr, int value0, int value1)
    {
        pr.first += value0 + value1;
        return pr;
    }
}

int main()
{
    int one = 1, two = 2;
    std::string dummy1 = "dummy1";
    std::string dummy2 = "dummy2";

    namespace traversal = boost::traversal;

    std::pair<int, bool> state(0, false);
    BOOST_TEST(traversal::tu_extend(add1)(state, one).first == 1);
    BOOST_TEST(traversal::tu_extend(add1)(state, dummy1).first == 0);

    BOOST_TEST(traversal::tu_extend(add2)(state, one, two).first == 3);
    BOOST_TEST(traversal::tu_extend(add2)(state, dummy1, dummy2).first == 0);

    return boost::report_errors();
}
