/*=============================================================================
    Copyright (c) 2007-2008 Dan Marsden

    Distributed under the Boost Software License, Version 1.0. (See accompanying 
    file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
==============================================================================*/

#include <boost/traversal/pattern/boost_pointer.hpp>
#include <boost/traversal/pattern/wildcard.hpp>

#include <boost/mpl/assert.hpp>
#include <boost/mpl/apply.hpp>

#include <boost/shared_ptr.hpp>
#include <boost/scoped_ptr.hpp>
#include <boost/shared_array.hpp>
#include <boost/scoped_array.hpp>
#include <boost/weak_ptr.hpp>
#include <boost/intrusive_ptr.hpp>


using namespace boost::traversal;
namespace mpl = boost::mpl;

int main()
{
    BOOST_MPL_ASSERT((mpl::apply<pattern::shared_ptr<pattern::_>, boost::shared_ptr<int> >));
    BOOST_MPL_ASSERT_NOT((mpl::apply<pattern::shared_ptr<pattern::_>, int>));

    BOOST_MPL_ASSERT((mpl::apply<pattern::scoped_ptr<pattern::_>, boost::scoped_ptr<int> >));
    BOOST_MPL_ASSERT_NOT((mpl::apply<pattern::scoped_ptr<pattern::_>, int>));

    BOOST_MPL_ASSERT((mpl::apply<pattern::shared_array<pattern::_>, boost::shared_array<int> >));
    BOOST_MPL_ASSERT_NOT((mpl::apply<pattern::shared_array<pattern::_>, int>));

    BOOST_MPL_ASSERT((mpl::apply<pattern::scoped_array<pattern::_>, boost::scoped_array<int> >));
    BOOST_MPL_ASSERT_NOT((mpl::apply<pattern::scoped_array<pattern::_>, int>));

    BOOST_MPL_ASSERT((mpl::apply<pattern::weak_ptr<pattern::_>, boost::weak_ptr<int> >));
    BOOST_MPL_ASSERT_NOT((mpl::apply<pattern::weak_ptr<pattern::_>, int>));

    BOOST_MPL_ASSERT((mpl::apply<pattern::intrusive_ptr<pattern::_>, boost::intrusive_ptr<int> >));
    BOOST_MPL_ASSERT_NOT((mpl::apply<pattern::intrusive_ptr<pattern::_>, int>));
}
