/*=============================================================================
    Copyright (c) 2007-2008 Dan Marsden

    Distributed under the Boost Software License, Version 1.0. (See accompanying 
    file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
==============================================================================*/

#include <boost/traversal/pattern/fusion.hpp>
#include <boost/traversal/pattern/wildcard.hpp>
#include <boost/traversal/pattern/lit.hpp>

#include <boost/mpl/assert.hpp>
#include <boost/mpl/apply.hpp>

#include <boost/fusion/container/vector.hpp>

using namespace boost::traversal;
namespace mpl = boost::mpl;
namespace fusion = boost::fusion;

int main()
{
    BOOST_MPL_ASSERT((mpl::apply<pattern::fusion<>, fusion::vector<> >));
    BOOST_MPL_ASSERT_NOT((mpl::apply<pattern::fusion<>, int>));

    BOOST_MPL_ASSERT((mpl::apply<pattern::fusion<pattern::_>, fusion::vector<int> >));
    BOOST_MPL_ASSERT_NOT((mpl::apply<pattern::fusion<pattern::_>, int>));
    BOOST_MPL_ASSERT_NOT((mpl::apply<pattern::fusion<pattern::lit<double> >, fusion::vector<int> >));

    BOOST_MPL_ASSERT((mpl::apply<pattern::fusion<pattern::_, pattern::_>, fusion::vector<int, int> >));
    BOOST_MPL_ASSERT_NOT((mpl::apply<pattern::fusion<pattern::_, pattern::_>, int>));
    BOOST_MPL_ASSERT_NOT((mpl::apply<pattern::fusion<pattern::lit<double>, pattern::lit<double> >, fusion::vector<int, int> >));

    BOOST_MPL_ASSERT((mpl::apply<pattern::fusion<pattern::_, pattern::_, pattern::_>, fusion::vector<int, int, int> >));
    BOOST_MPL_ASSERT_NOT((mpl::apply<pattern::fusion<pattern::_, pattern::_, pattern::_>, int>));
    BOOST_MPL_ASSERT_NOT((mpl::apply<pattern::fusion<pattern::lit<double>, pattern::lit<double>, pattern::lit<double> >, fusion::vector<int, int, int> >));
}
