/*=============================================================================
    Copyright (c) 2007-2008 Dan Marsden

    Distributed under the Boost Software License, Version 1.0. (See accompanying 
    file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
==============================================================================*/

#include <boost/traversal/pattern/variant.hpp>

#include <boost/traversal/pattern/wildcard.hpp>
#include <boost/traversal/pattern/lit.hpp>

#include <boost/mpl/assert.hpp>
#include <boost/mpl/apply.hpp>

#include <boost/variant.hpp>

using namespace boost::traversal;
namespace mpl = boost::mpl;

int main()
{
    typedef boost::variant<int> variant_type;
    BOOST_MPL_ASSERT((mpl::apply<pattern::variant<pattern::_>, boost::variant<int> >));
    BOOST_MPL_ASSERT_NOT((mpl::apply<pattern::variant<pattern::_>, int>));

    BOOST_MPL_ASSERT((mpl::apply<pattern::variant<pattern::_, pattern::_>, boost::variant<int, double> >));
    BOOST_MPL_ASSERT_NOT((mpl::apply<pattern::variant<pattern::_, pattern::_>, int>));
}
