/*=============================================================================
    Copyright (c) 2007-2008 Dan Marsden

    Distributed under the Boost Software License, Version 1.0. (See accompanying 
    file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
==============================================================================*/
#include <boost/traversal/recursive/reverse_once_parent.hpp>
#include <boost/detail/lightweight_test.hpp>

#include <boost/variant.hpp>

using namespace boost;

namespace
{
    struct nil_t {};

    nil_t const nil = nil_t();
    
    struct parent_traverser
    {
        template<typename Child, typename Parent>
        bool operator()(Child& child, Parent& parent) const
        {
            return false;
        }

        template<typename Parent>
        bool operator()(nil_t&, Parent& parent) const
        {
            parent = 202;
            return false;
        }
    };
}

int main()
{
    typedef variant<int, nil_t> v_type;
    v_type v(101);
    traversal::reverse_once_parent(v, parent_traverser());
    BOOST_TEST(get<int>(v) == 101);
    
    v_type v2(nil);
    traversal::reverse_once_parent(v2, parent_traverser());
    BOOST_TEST(get<int>(v2) == 202);
    return boost::report_errors();
}
