/*=============================================================================
    Copyright (c) 2007-2008 Dan Marsden

    Distributed under the Boost Software License, Version 1.0. (See accompanying 
    file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
==============================================================================*/
#include <boost/traversal/support/tag_of.hpp>

#include <vector>
#include <boost/fusion/container/vector.hpp>
#include <boost/variant.hpp>
#include <boost/optional.hpp>

#include <boost/mpl/assert.hpp>
#include <boost/type_traits/is_same.hpp>

int main()
{
    namespace traversal = boost::traversal;
    namespace traits = boost::traversal::traits;
    namespace fusion = boost::fusion;

    BOOST_MPL_ASSERT((boost::is_same<traits::tag_of<int>::type, traits::unstructured_tag>));
    BOOST_MPL_ASSERT((boost::is_same<traits::tag_of<std::vector<int> >::type, traits::container_tag>));
    BOOST_MPL_ASSERT((boost::is_same<traits::tag_of<fusion::vector<int> >::type, traits::fusion_sequence_tag>));
    BOOST_MPL_ASSERT((boost::is_same<traits::tag_of<boost::optional<int> >::type, traits::optional_tag>));
    BOOST_MPL_ASSERT((boost::is_same<traits::tag_of<boost::variant<int, char> >::type, traits::variant_tag>));
    BOOST_MPL_ASSERT((boost::is_same<traits::tag_of<int*>::type, traits::pointer_tag>));
}
